{
  "openapi": "3.0.4",
  "info": {
    "title": "Public Api",
    "description": "# Introduction\n\nThis API allows resellers to manage their resources in a simple, programmatic way using HTTP requests.\n\n# Conventions\n\n## Requests\n\nThe API supports different methods depending on the required action.\n\n| Method\t| Description\n| ---\t\t| ---\n| GET\t\t| Retrieve resources in a collection or get a single resource.<br/>Getters will never have any effect on the queried resources.\n| POST\t\t| Create a new resource in a collection.\n| PUT\t\t| Update an existing resource with its new representation.\n| DELETE\t| Delete an existing resource.\n\n## HTTP status codes\n\nThe API will reply with different HTTP statuscodes:\n\n| StatusCode\t\t\t\t| Description\n| ---\t\t\t\t\t\t| ---\n| 200 OK\t\t\t\t\t| The requests was processed and you receive data as a result.\n| 201 CREATED\t\t\t\t| The resource has been created. Either the Location header contains a link to the created resource, or links are being returned in the response body. The applied method will be indicated in the documentation.\n| 202 ACCEPTED\t\t\t\t| The request has been validated and accepted. Because we need to do some background processing prior to returning the result, we cannot send back a useful representation.\n| 204 NOCONTENT\t\t\t\t| The request has been processed, but no details can be returned.\n| 400 BADREQUEST\t\t\t| Your request is malformed.\n| 401 UNAUTHORIZED\t\t\t| You are not authorized. Follow the instructions in the Authorization documentation.\n| 403 FORBIDDEN\t\t\t\t| Access to the resource or operation is not allowed.\n| 404 NOTFOUND\t\t\t\t| The resource cannot be found.\n| 410 GONE                  | The resource is permanently no longer available.\n| 429 TOOMANYREQUESTS\t\t| The ratelimit has been exceeded. Please refer to the documentation on rate limiting for more details.\n| 500 INTERNALSERVERERROR\t| An error occurred during the processing of the request. The error is unexpected and most likely due to a bug in the api.\n\nIn the event of a problem, the body of the response will usually contain an errorcode and errormessage.\nIn rare cases additional details about the error are reported.\n\nErrorcodes 400-499 are considered to be client errors and indicate that there was an issue with the request.\nWe will not take any action besides monitoring. \n\nErrorcodes 500-599 are considered to be server errors. The errors are monitored AND action will be taken to resolve the error.\n\n## Formatting\n\nSnake casing is applied on resources and query parameters.\nThe API is strictly returning JSON. No other formats are supported.\n\nDatetimes are returned in ISO-8601 format.\n\n## Pagination\n\nPagination is on by default on collections and is controlled by specifying *skip* and *take* parameters.  \n**Skip** indicates the number of results to skip and where to start the new take.  \n**Take** indicates the number of records to return. The returned number of items can be smaller than the requested take.\n\nPaged results will have headers with useful information regarding the paging.\n\n| Header\t\t\t\t| Description\n| ---\t\t\t\t\t| ---\n| X-Paging-Skipped\t\t| The number of results that have been skipped.\n| X-Paging-Take\t\t\t| The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.\n| X-Paging-TotalResults | The total number of results regardless of paging.\n\n## Rate limiting\n\nThe number of requests per interval is limited. Detailed information on the rate limiting can be found in specific headers which will be sent on each request.\n\n| Header\t\t\t\t| Description\n| ---\t\t\t\t\t| ---\n| X-RateLimit-Limit\t\t| The number of requests that can be made in a specific time interval.\n| X-RateLimit-Usage\t\t| The number of requests already made in the current time interval.\n| X-RateLimit-Remaining\t| The number of requests remaining until the reset.\n| X-RateLimit-Reset\t\t| The number of seconds until the reset.<br />After the reset you are allowed to make as many requests as specified by the X-RateLimit-Limit header.\n| Retry-After\t\t\t| The number of seconds you have to wait until you can make new requests.<br />This header is only present when the rate limit has been reached. It is identical to X-RateLimit-Reset.\n\nWhen the ratelimit has been reached, all requests will return with a HTTP statuscode 429 and ReasonPhrase '*Too many requests, retry later.*'.\n\n# Authentication\n\nThe Api uses HMAC authentication.  \nHash-based message authentication code (HMAC) is a mechanism for calculating a message authentication code involving a hash function in combination with a secret key.  \nBoth the integrity and the authenticity of the message are verified this way.\n\n## Steps to generate the HMAC\n\n1. Get your api key and secret from your controlpanel.  \nIt is absolutely vital that the secret is never exposed. Once the secret is out, anyone would be able to generate hmacs to impersonate you.  \nIn case your secret is compromised, you can generate a new api key and secret on your controlpanel.\n2. Construct the input value for generating the hmac.  \nConcatenate:apikey, request method, path and querystring information, unix timestamp, nonce and content.\n\n|\t\t\t\t\t\t\t\t\t\t| Description\n| ---\t\t\t\t\t\t\t\t\t| ---\n| apikey\t\t\t\t\t\t\t\t| The key that is linked to your user.\n| request method\t\t\t\t\t\t| lowercased (eg: get, post, delete,...)\n| path and querystring information\t\t| urlencoding of the lowercased relative path and querystring.<br />The path **MUST start with the api version (/v2)**.<br />The hexadecimal codes (percent encoding) MUST be uppercased.\n| unix timestamp\t\t\t\t\t\t| the unix timestamp in **seconds**.\n| nonce\t\t\t\t\t\t\t\t\t| a\tunique string for each request. It should be a random string, not related to the request. The nonce (in combination with the unix timestamp) protects you from replay attacks in case anyone was able to intercept a request.\n| content\t\t\t\t\t\t\t\t| When the request body is not empty, this should be the Base64 encoded Md5 hash of the request body.<br />An empty body should not be encoded.\n\n3. Hash the concatenated string using your api secret and the SHA-256 algorithm.\n4. Base64 encode the result of the hash function. This is the hmac signature you will need to send an authorized request.\n\n## Sending an authorized request\n\nAn authorized request can be made by sending the generated HMAC in the authorization header.  \nA correct authorizationheader uses the hmac authorization scheme and a correctly formatted authorization parameter.\n\nCreate the authorization parameter by concatenating:\n  * apikey\n  * colon ':'\n  * generated HMAC signature (see above)\n  * colon ':'\n  * nonce (the one used to generate the signature)\n  * colon ':'\n  * unix timestamp (the one used to generate the signature)\n\nA sample (illustrated):\n\n* The first line is the string you create to feed to the hashing algorithm.\n* The second line is the authorization header that should be sent in the request.\n\n![hmac authorization header illustrated](/v2/images/authentication_illustration.jpg \"authorization header illustrated\")\n\n## IP whitelisting\n\nAccess is by default restricted for all IP addresses. You need to explicitly whitelist an IP or an IP range in your controlpanel.\n\n# Versioning\n\nBecause of breaking contract changes compared to v1, we released v2 of the API.  \nV1 will still be available, but you are strongly encouraged to migrate to the latest version.  \nNew features will only be available on v2.\n\n# Policy\n\n### Fair use policy\n\nPlease respect the rate limits and do not use the api for any purposes of abuse.  \nAll requests are being monitored and logged.  \nIntentional abuse might result in api key revocation.\n\n# Errors\n\nThe API attempts to return appropriate HTTP status codes for every request.  \nWhen the status code indicates failure, the API will also provide an error message in most cases.\n\nAn error message contains a machine-parseable error code accompanied by a descriptive error text.  \nThe text for an error message might change over time, but codes will stay the same.\n\n[An overview of error codes can be found here](/v2/documentation/errorcodes).\n\n# Change log\n\n[An overview of new changes can be found here](/v2/documentation/changelog).\n\n# Provisioning information\n\n## Terminology\n\n| Term\t\t\t| Definition\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t|\n| ---\t\t\t| ---\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t|\n| Servicepack\t| Defines a set of assets that belong together. An example is a hosting package which offers Linux hosting, a domain name, a couple of mailboxes and databases.<br/>It also limits the size of individual assets within the same account. |\n| Account\t\t| Represents an instance of the servicepack. It contains one or more assets. The number and size of assets is defined by the servicepack. |\n| Asset\t\t\t| A manageable service. For example: a mysql database, a linux hosting, a mailbox,...<br/>Some assets are created at the moment when the account is created. Other assets can be created afterwards.\n\t\n## Common provisioning scenario\n\n**Provisioning of an account with Linux hosting with one MySql database**\n\n*Without a pre-existing account:*\n\n1. Create a new account.<br/>Perform a POST on the accounts route and provide the desired servicepack id and identifier (domain name).\n2. Read the Location header from the response and perform a GET of the provided resource (a provisioning job).\n3. When the response returns 200(OK), you should repeat the GET operation after a certain interval (Repeat this step).<br/>\nWhen the response returns 201(Created), you should read the response body. This will contain links to the created resources.<br/>\nThis will usually hold only one link, but to be futureproof, this has been designed to return a collection.\n4. The created resource will point to an account. You now know the account's Id and can continue with the provisioning of a MySql database on this account.\n5. Perform a POST on the mysqldatabases route and provide the account id along with other requested information.\n6. Read the Location header from the response and perform a GET of the provided resource (a provisioning job).\n7. When the response returns 200(OK), you should repeat the GET operation after a certain interval (Repeat this step).<br/>\nWhen the response returns 201(Created), you should read the response body. This will contain links to the created resources.<br/>\nThis will usually hold only one link, but to be futureproof, this has been designed to return a collection.\n8. The created resource will point to a MySql database resource.\n\n## SSL certificate requests\n\n**Requesting an SSL certificate causes the purchase of a paying product.**\n\n1. A certificate is created by adding an ssl certificate request.\n2. Upon statuscode 201 you should query for certificate completion on the resource provided in the location response header.\n3. The resource request can respond with different statuscodes:\n<ul>\n    <li>200: the certificate request is ongoing.<br/>\nCheck the validations collection for validation values that are not auto_validated. Those should be set by you system.<br/>\nCall verify domain validations once all validation values are in place. It might take some time for verification to take place. It is not necessary to call this method more than once.</li>\n    <li>303: the certificate request is complete; there is no more certificate request resource available. Check the location header value to retrieve the representation of the resulting ssl certificate.</li>\n    <li>410: the certificate request does not exist anymore, there is no certificate created as a result of the request.</li>\n</ul>",
    "version": "v2"
  },
  "servers": [
    {
      "url": "/v2"
    }
  ],
  "paths": {
    "/accounts": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Overview of accounts",
        "operationId": "GetAccounts",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "asset_type",
            "in": "query",
            "description": "Filters the list, returning only accounts containing the specified asset type.",
            "schema": {
              "$ref": "#/components/schemas/AssetType"
            }
          },
          {
            "name": "identifier",
            "in": "query",
            "description": "Return only accounts, matching the specified identifier.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Account"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Accounts"
        ],
        "summary": "Create a new account",
        "description": "The creation of an account requires some background processing. There is no instant feedback of the creation status.",
        "operationId": "CreateAccount",
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateAccount"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      }
    },
    "/accounts/{accountId}": {
      "get": {
        "tags": [
          "Accounts"
        ],
        "summary": "Get a specific account",
        "description": "",
        "operationId": "GetAccount",
        "parameters": [
          {
            "name": "account_id",
            "in": "path",
            "description": "The id of the account.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/AccountDetail"
                }
              }
            }
          }
        }
      }
    },
    "/dns/{domainName}/records": {
      "get": {
        "tags": [
          "DNS records"
        ],
        "summary": "Get records",
        "operationId": "GetRecords",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "type",
            "in": "query",
            "description": "Filters records matching the type. Most other filters only apply when this filter is specified.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "record_name",
            "in": "query",
            "description": "Filters records matching the record name. This filter only applies to lookups of A, AAAA, CAA, CNAME, MX, TXT, SRV, ALIAS and TLSA records.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "service",
            "in": "query",
            "description": "Filters records for the service. This filter only applies to lookups of SRV records.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/DnsRecord"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "DNS records"
        ],
        "summary": "Create a record",
        "operationId": "CreateRecord",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "The record to create",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/DnsRecord"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/dns/{domainName}/records/{recordId}": {
      "get": {
        "tags": [
          "DNS records"
        ],
        "summary": "Get specific record",
        "operationId": "GetRecord",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "record_id",
            "in": "path",
            "description": "The id of the record.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DnsRecord"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "DNS records"
        ],
        "summary": "Edit a record",
        "operationId": "EditRecord",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "record_id",
            "in": "path",
            "description": "The id of the record.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "The record with updated values.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/DnsRecord"
              }
            }
          }
        },
        "responses": {
          "200": {
            "description": "OK"
          }
        }
      },
      "delete": {
        "tags": [
          "DNS records"
        ],
        "summary": "Delete a record",
        "operationId": "DeleteRecord",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "record_id",
            "in": "path",
            "description": "The id of the record.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/domains": {
      "get": {
        "tags": [
          "Domains"
        ],
        "summary": "Overviews of domains",
        "operationId": "GetDomains",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Domain"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/domains/{domainName}": {
      "get": {
        "tags": [
          "Domains"
        ],
        "summary": "Details of a domain",
        "operationId": "GetDomain",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/DomainDetail"
                }
              }
            }
          }
        }
      }
    },
    "/domains/registrations": {
      "post": {
        "tags": [
          "Domains"
        ],
        "summary": "Register a domain",
        "description": "Registers an available domain.\r\nDomain names with extension '.ca' are only available for registrants with country code 'CA'.",
        "operationId": "Register",
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/RegisterDomain"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          }
        }
      }
    },
    "/domains/transfers": {
      "post": {
        "tags": [
          "Domains"
        ],
        "summary": "Transfer a domain",
        "description": "Transfers a domain with a transfer authorization code.\r\nDomain names with extension '.ca' are only available for registrants with country code 'CA'.",
        "operationId": "Transfer",
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/TransferDomain"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          }
        }
      }
    },
    "/domains/{domainName}/nameservers": {
      "put": {
        "tags": [
          "Domains"
        ],
        "summary": "Edit domain name servers",
        "description": "",
        "operationId": "EditNameServers",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EditNameServers"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/domains/{domainName}/renew": {
      "put": {
        "tags": [
          "Domains"
        ],
        "summary": "Edit domain name renew state",
        "description": "Allowed if can_toggle_renew is true on the domain detail:\r\n<ul><li>If there are no unpaid invoices for the domain name anymore.</li><li>If the renewal won't start within 1 month.</li></ul>\r\nAllowed if the requesting user has the finance role.",
        "operationId": "ConfigureDomain",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The domain name",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the domain renew information",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/EditDomainWillRenewRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Overview of linux hostings",
        "operationId": "GetLinuxHostings",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/LinuxHosting"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Linux hosting detail",
        "operationId": "GetLinuxHosting",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/LinuxHostingDetail"
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/phpsettings/availableversions": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Get the available PHP versions.",
        "operationId": "GetAvailablePhpVersions",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/PhpVersion"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/phpsettings/version": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Change the Linux hosting PHP version.",
        "operationId": "ChangePhpVersion",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "The new PHP version.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/PhpVersion"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/settings/gzipcompression": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Enable/disable GZIP compression",
        "operationId": "ChangeGzipCompression",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Whether GZIP compression is enabled or not.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/GzipConfig"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/subsites": {
      "post": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Create a subsite",
        "operationId": "CreateSubsite",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Add subsite request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddSubsiteRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/subsites/{siteName}": {
      "delete": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Delete a subsite",
        "operationId": "DeleteSubsite",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "site_name",
            "in": "path",
            "description": "Name of the site on the linux hosting.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/sites/{siteName}/hostheaders": {
      "post": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Create a host header",
        "operationId": "CreateHostHeader",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "site_name",
            "in": "path",
            "description": "Name of the site on the linux hosting.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Add host header request",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddHostHeaderRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/sites/{siteName}/http2/configuration": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure HTTP/2",
        "operationId": "ConfigureHttp2",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "site_name",
            "in": "path",
            "description": "Site name where HTTP/2 should be configured.\r\n\r\nFor HTTP/2 to work correctly, the site must have ssl enabled.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/Http2Configuration"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/ftp/configuration": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure FTP",
        "operationId": "ConfigureFtp",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/FtpConfiguration"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/sslsettings/{hostname}/letsencrypt": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure let's encrypt",
        "operationId": "ChangeLetsEncrypt",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "hostname",
            "in": "path",
            "description": "Specific hostname.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Let's encrypt config.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/LetsEncryptConfig"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/sslsettings/{hostname}/autoredirect": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure auto redirect",
        "operationId": "ChangeAutoRedirect",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "hostname",
            "in": "path",
            "description": "Specific hostname.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Auto redirect config.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AutoRedirectConfig"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/phpsettings/memorylimit": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure PHP memory limit",
        "operationId": "ChangePhpMemoryLimit",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Memory limit config",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdatePhpMemoryLimitRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/phpsettings/apcu": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure PHP APCu setting",
        "operationId": "ChangeApcu",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Php APcu config",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdatePhpAPcuRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/scheduledtasks": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Overview of scheduled tasks",
        "description": "Manage scheduled tasks which are also manageable via the control panel.",
        "operationId": "GetScheduledTasks",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/ScheduledTask"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Add a scheduled task",
        "operationId": "AddScheduledTasks",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ScheduledTask"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/scheduledtasks/{scheduledTaskId}": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Get scheduled task detail",
        "operationId": "GetScheduledTask",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_task_id",
            "in": "path",
            "description": "Id of the scheduled task.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ScheduledTask"
                }
              }
            }
          }
        }
      },
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure a scheduled task",
        "operationId": "ConfigureScheduledTask",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_task_id",
            "in": "path",
            "description": "Id of the scheduled task.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/ScheduledTask"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      },
      "delete": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Delete a scheduled task",
        "operationId": "DeleteScheduledTask",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "scheduled_task_id",
            "in": "path",
            "description": "Id of the scheduled task.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/ssh/keys": {
      "get": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Overview of SSH keys",
        "operationId": "GetSshKeys",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/SshKey"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Add a SSH key",
        "operationId": "AddSshKey",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "SSH key public key.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AddSshKeyRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/linuxhostings/{domainName}/ssh/configuration": {
      "put": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Configure SSH",
        "operationId": "ConfigureSsh",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/SshConfiguration"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/linuxhostings/{domainName}/ssh/keys/{fingerprint}": {
      "delete": {
        "tags": [
          "Linux hostings"
        ],
        "summary": "Delete a SSH key",
        "operationId": "DeleteSshKey",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Linux hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "fingerprint",
            "in": "path",
            "description": "Fingerprint of public key.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/mailboxes": {
      "get": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Gets your mailboxes.",
        "description": "Currently only supports getting the mailboxes filtered by domain name.",
        "operationId": "GetMailboxes",
        "parameters": [
          {
            "name": "domain_name",
            "in": "query",
            "description": "Obligated domain name for getting mailboxes.",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Mailbox"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Create a new mailbox.",
        "operationId": "CreateMailbox",
        "requestBody": {
          "description": "The add mailbox request.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateMailboxRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/mailboxes/{mailboxName}": {
      "get": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Get a specific mailbox",
        "operationId": "GetMailbox",
        "parameters": [
          {
            "name": "mailbox_name",
            "in": "path",
            "description": "Mailbox name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/MailboxDetail"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Delete a mailbox",
        "operationId": "DeleteMailbox",
        "parameters": [
          {
            "name": "mailbox_name",
            "in": "path",
            "description": "Mailbox name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/mailboxes/{mailboxName}/password": {
      "put": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Change password for mailbox",
        "operationId": "ChangeMailboxPassword",
        "parameters": [
          {
            "name": "mailbox_name",
            "in": "path",
            "description": "Mailbox name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the new password.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateMailboxPasswordRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mailboxes/{mailboxName}/autoreply": {
      "put": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Configure auto-reply for mailbox",
        "operationId": "ConfigureMailboxAutoReply",
        "parameters": [
          {
            "name": "mailbox_name",
            "in": "path",
            "description": "Mailbox name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the auto-reply information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AutoReply"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mailboxes/{mailboxName}/autoforward": {
      "put": {
        "tags": [
          "Mailboxes"
        ],
        "summary": "Configure auto-forward for mailbox",
        "operationId": "ConfigureMailboxAutoForward",
        "parameters": [
          {
            "name": "mailbox_name",
            "in": "path",
            "description": "Mailbox name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the auto-forward information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/AutoForward"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mailzones/{domainName}": {
      "get": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Get the mail zone.",
        "operationId": "GetMailZone",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/MailZone"
                }
              }
            }
          }
        }
      }
    },
    "/mailzones/{domainName}/catchall": {
      "post": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Create a catch-all on the mail zone",
        "operationId": "CreateCatchAll",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the catch-all information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateCatchAllRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/mailzones/{domainName}/catchall/{emailAddress}": {
      "delete": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Delete a catch-all on the mail zone",
        "operationId": "DeleteCatchAll",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "email_address",
            "in": "path",
            "description": "E-mail address to which all e-mails are sent to inexistent mailboxes or aliases.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mailzones/{domainName}/antispam": {
      "put": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Configure anti-spam for mail zone",
        "operationId": "ConfigureAntiSpam",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the anti-spam information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateAntiSpamRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mailzones/{domainName}/aliases": {
      "post": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Create a new alias",
        "operationId": "CreateAlias",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the alias information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateAliasRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      }
    },
    "/mailzones/{domainName}/aliases/{emailAddress}": {
      "put": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Configure a alias",
        "operationId": "ConfigureAlias",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "email_address",
            "in": "path",
            "description": "Alias e-mail address.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the alias information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateAliasRequest"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Delete a alias",
        "operationId": "DeleteAlias",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "email_address",
            "in": "path",
            "description": "Alias e-mail address.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/mailzones/{domainName}/smtpdomains": {
      "post": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Create an extra smtp domain",
        "operationId": "CreateSmtpDomain",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the smtp domain information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateSmtpDomainRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      }
    },
    "/mailzones/{domainName}/smtpdomains/{hostname}": {
      "put": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Configure an extra smtp domain",
        "operationId": "ConfigureSmtpDomain",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "hostname",
            "in": "path",
            "description": "Smtp domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the smtp domain information.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateSmtpDomainRequest"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "Mail zones"
        ],
        "summary": "Delete an extra smtp domain",
        "operationId": "DeleteSmtpDomain",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "Mail zone domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "hostname",
            "in": "path",
            "description": "Smtp domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/mysqldatabases": {
      "get": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Overview of mysql databases",
        "operationId": "GetMySqlDatabases",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/MySqlDatabase"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Create a new mysql database",
        "operationId": "CreateMySqlDatabase",
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateMySqlDatabase"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      }
    },
    "/mysqldatabases/{databaseName}": {
      "get": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Get a specific database",
        "operationId": "GetMySqlDatabase",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/MySqlDatabase"
                }
              }
            }
          }
        }
      },
      "delete": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Delete a mysql database",
        "operationId": "DeleteDatabase",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/mysqldatabases/{databaseName}/users": {
      "get": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Overview of mysql users",
        "operationId": "GetDatabaseUsers",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/MySqlUser"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Create a new mysql user",
        "description": "The creation of a new mysql user will result in a user with read_only rights.",
        "operationId": "CreateMySqlUser",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateMySqlUser"
              }
            }
          }
        },
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "400": {
            "description": "Bad Request",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/BadRequestResponse"
                }
              }
            }
          }
        }
      }
    },
    "/mysqldatabases/{databaseName}/users/{userName}/status": {
      "put": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Enable/disable mysql user",
        "operationId": "ChangeDatabaseUserStatus",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "user_name",
            "in": "path",
            "description": "Name of the user.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Whether the user is enabled or not.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateUserStatusRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mysqldatabases/{databaseName}/users/{userName}/password": {
      "put": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Change password for mysql user",
        "operationId": "ChangeDatabaseUserPassword",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "user_name",
            "in": "path",
            "description": "Name of the user.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "requestBody": {
          "description": "Contains the new password.",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/UpdateUserPasswordRequest"
              }
            }
          }
        },
        "responses": {
          "204": {
            "description": "No Content"
          }
        }
      }
    },
    "/mysqldatabases/{databaseName}/users/{userName}": {
      "delete": {
        "tags": [
          "MySql databases"
        ],
        "summary": "Delete a mysql user",
        "description": "The deletion of a mysql user is allowed for users with read_only rights.",
        "operationId": "DeleteDatabaseUser",
        "parameters": [
          {
            "name": "database_name",
            "in": "path",
            "description": "Name of the database.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "user_name",
            "in": "path",
            "description": "Name of the user.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "204": {
            "description": "No Content"
          },
          "400": {
            "description": "Bad Request"
          }
        }
      }
    },
    "/provisioningjobs/{jobId}": {
      "get": {
        "tags": [
          "Provisioning jobs"
        ],
        "summary": "Detail of a provisioning job",
        "description": "Provisioning failures may occur. Contact support in the event of a failure or wait for error resolution.\r\n\r\nDo NOT retry provisioning until the job reports finished or cancelled.",
        "operationId": "GetProvisioningJob",
        "parameters": [
          {
            "name": "job_id",
            "in": "path",
            "required": true,
            "schema": {
              "type": "string",
              "format": "uuid"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProvisioningJobInfo"
                }
              }
            }
          },
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/ProvisioningJobCompletion"
                }
              }
            }
          }
        }
      }
    },
    "/servicepacks": {
      "get": {
        "tags": [
          "Servicepacks"
        ],
        "summary": "Overview of service packs",
        "operationId": "Servicepacks",
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/Servicepack"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/ssh": {
      "get": {
        "tags": [
          "SSH"
        ],
        "summary": "Overview of SSH keys",
        "operationId": "GetAllSshKeys",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/SshKeyDetail"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/sslcertificaterequests": {
      "get": {
        "tags": [
          "SSL certificate requests"
        ],
        "summary": "Overview of SSL certificate requests",
        "operationId": "GetSslCertificateRequests",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/SslCertificateRequest"
                  }
                }
              }
            }
          }
        }
      },
      "post": {
        "tags": [
          "SSL certificate requests"
        ],
        "summary": "Add a SSL certificate request",
        "description": "Executing this method causes the purchase of a paying product.\r\n\r\nLog on to our website to see your current (renewal) prices or contact our Sales department.\r\n\r\nPlease note that promotional pricing does not apply for purchases made through our API.",
        "operationId": "AddSslCertificateRequest",
        "requestBody": {
          "description": "",
          "content": {
            "application/json": {
              "schema": {
                "$ref": "#/components/schemas/CreateSslCertificateRequest"
              }
            }
          }
        },
        "responses": {
          "201": {
            "description": "Created",
            "headers": {
              "Location": {
                "description": "The location of the created resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          }
        }
      }
    },
    "/sslcertificaterequests/{id}": {
      "get": {
        "tags": [
          "SSL certificate requests"
        ],
        "summary": "Detail of a SSL certificate request",
        "operationId": "GetSslCertificateRequest",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "The id of the certificate request.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SslCertificateRequestDetail"
                }
              }
            }
          },
          "303": {
            "description": "See Other",
            "headers": {
              "Location": {
                "description": "The location referring to a resource that replaced the original resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "410": {
            "description": "The resource existed in the past, but is no longer available."
          }
        }
      },
      "put": {
        "tags": [
          "SSL certificate requests"
        ],
        "summary": "Verify the SSL certificate request domain validations",
        "operationId": "VerifySslCertificateRequestDomainValidations",
        "parameters": [
          {
            "name": "id",
            "in": "path",
            "description": "The id of the certificate request.",
            "required": true,
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "202": {
            "description": "Accepted"
          },
          "303": {
            "description": "See Other",
            "headers": {
              "Location": {
                "description": "The location referring to a resource that replaced the original resource.",
                "schema": {
                  "type": "string"
                }
              }
            }
          },
          "410": {
            "description": "The resource existed in the past, but is no longer available."
          }
        }
      }
    },
    "/sslcertificates": {
      "get": {
        "tags": [
          "SSL certificates"
        ],
        "summary": "Overview of SSL certificates",
        "operationId": "GetSslCertificates",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/SslCertificate"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/sslcertificates/{sha1Fingerprint}": {
      "get": {
        "tags": [
          "SSL certificates"
        ],
        "summary": "Detail of a SSL certificate",
        "operationId": "GetSslCertificate",
        "parameters": [
          {
            "name": "sha1_fingerprint",
            "in": "path",
            "description": "The SHA-1 fingerprint of the certificate.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/SslCertificateDetail"
                }
              }
            }
          }
        }
      }
    },
    "/sslcertificates/{sha1Fingerprint}/download": {
      "get": {
        "tags": [
          "SSL certificates"
        ],
        "summary": "Download a SSL certificate",
        "description": "Returns the certifcate as binary data with the content-type and the filename information in the response headers.",
        "operationId": "DownloadCertificate",
        "parameters": [
          {
            "name": "sha1_fingerprint",
            "in": "path",
            "description": "The SHA-1 fingerprint of the certificate.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "file_format",
            "in": "query",
            "description": "The file format of the returned file stream:\r\n<ul><li>PFX: Also known as PKCS #12, is a single, password protected certificate archive that contains the entire certificate chain plus the matching private key.</li></ul>",
            "required": true,
            "schema": {
              "$ref": "#/components/schemas/SslCertificateFileFormat"
            }
          },
          {
            "name": "password",
            "in": "query",
            "description": "The password used to protect the certificate file.\r\n",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "type": "string",
                  "format": "binary"
                }
              }
            }
          },
          "400": {
            "description": "Invalid file_format or invalid password"
          }
        }
      }
    },
    "/windowshostings": {
      "get": {
        "tags": [
          "Windows hostings"
        ],
        "summary": "Overview of windows hostings",
        "operationId": "GetWindowsHostings",
        "parameters": [
          {
            "name": "skip",
            "in": "query",
            "description": "The number of items to skip in the resultset.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "take",
            "in": "query",
            "description": "The number of items to return in the resultset. The returned count can be equal or less than this number.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "headers": {
              "X-Paging-Skipped": {
                "description": "The number of results that have been skipped.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-Take": {
                "description": "The number of items in the current take. The number might differ from the requested take. It represents the actual number of items returned in the response.",
                "schema": {
                  "type": "integer"
                }
              },
              "X-Paging-TotalResults": {
                "description": "The total number of results regardless of paging.",
                "schema": {
                  "type": "integer"
                }
              }
            },
            "content": {
              "application/json": {
                "schema": {
                  "type": "array",
                  "items": {
                    "$ref": "#/components/schemas/WindowsHosting"
                  }
                }
              }
            }
          }
        }
      }
    },
    "/windowshostings/{domainName}": {
      "get": {
        "tags": [
          "Windows hostings"
        ],
        "summary": "Windows hosting detail",
        "operationId": "GetWindowsHosting",
        "parameters": [
          {
            "name": "domain_name",
            "in": "path",
            "description": "The Windows hosting domain name.",
            "required": true,
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "OK",
            "content": {
              "application/json": {
                "schema": {
                  "$ref": "#/components/schemas/WindowsHostingDetail"
                }
              }
            }
          }
        }
      }
    }
  },
  "components": {
    "schemas": {
      "Account": {
        "type": "object",
        "properties": {
          "id": {
            "type": "integer",
            "description": "The id of the account",
            "format": "int32"
          },
          "identifier": {
            "type": "string",
            "description": "Identifier for the account"
          },
          "servicepack_id": {
            "type": "integer",
            "description": "The servicepack id that defines the account.",
            "format": "int32"
          }
        },
        "additionalProperties": false
      },
      "AccountDetail": {
        "type": "object",
        "properties": {
          "id": {
            "type": "integer",
            "description": "The id of the account",
            "format": "int32"
          },
          "identifier": {
            "type": "string",
            "description": "Identifier for the account"
          },
          "servicepack": {
            "$ref": "#/components/schemas/Servicepack"
          },
          "addons": {
            "type": "array",
            "items": {
              "$ref": "#/components/schemas/Addon"
            },
            "description": "A list of addons applied to the account."
          }
        },
        "additionalProperties": false,
        "description": "A detailed representation of an account."
      },
      "AddHostHeaderRequest": {
        "type": "object",
        "properties": {
          "domain_name": {
            "type": "string",
            "description": "Host header domain name (e.g. alias.be or alias.site.be)."
          }
        },
        "additionalProperties": false
      },
      "AddSshKeyRequest": {
        "type": "object",
        "properties": {
          "public_key": {
            "type": "string",
            "description": "Public key"
          }
        },
        "additionalProperties": false
      },
      "AddSubsiteRequest": {
        "type": "object",
        "properties": {
          "domain_name": {
            "type": "string",
            "description": "Subsite domain name (e.g. alias.be or subsite.site.be)."
          },
          "path": {
            "type": "string",
            "description": "Folder location for the subsite (when empty we use /subsites/site (e.g. /subsites/subsite.site.be)\r\n\r\nThe path MUST pre-exist on the server. It WILL NOT be created automatically."
          }
        },
        "additionalProperties": false
      },
      "AdditionalValidationAttribute": {
        "type": "object",
        "properties": {
          "name": {
            "type": "string",
            "description": "Additional validation attribute field name."
          },
          "value": {
            "type": "string",
            "description": "Additional validation attribute field value."
          }
        },
        "additionalProperties": false
      },
      "Addon": {
        "type": "object",
        "properties": {
          "id": {
            "type": "integer",
            "description": "The id of the addon",
            "format": "int32"
          },
          "name": {
            "type": "string",
            "description": "The name of the addon"
          }
        },
        "additionalProperties": false,
        "description": "Addon information"
[...]
